<script lang="ts" setup>
import { useAccess } from '@vben/access';
import { Page, useVbenDrawer } from '@vben/common-ui';

import { Button, message, Modal } from 'ant-design-vue';

import { useVbenVxeGrid } from '#/adapter/vxe-table';
import { MenuApi } from '#/api';
import { TableAction } from '#/components/table-action';

import FormEdit from './components/edit.vue';
import { gridOptions, searchFormOptions } from './data.config';

const { hasAccessByCodes } = useAccess();

const [Grid, { reload }] = useVbenVxeGrid({
  formOptions: searchFormOptions,
  gridOptions,
});

const [FormEditModal, formEditApi] = useVbenDrawer({
  connectedComponent: FormEdit,
});

const handleDelete = (id: number) => {
  Modal.confirm({
    iconType: 'info',
    title: '删除提示',
    content: `确定要删除选择的记录吗?`,
    cancelText: `关闭`,
    onOk: async () => {
      await MenuApi.deleteDetail(id);
      message.success('数据删除成功');
      reload();
    },
  });
};

const handleEdit = (record: any, isUpdate: boolean) => {
  formEditApi.setData({
    isUpdate,
    baseData: { ...record },
  });

  formEditApi.open();
};

const handelSuccess = () => {
  reload();
};
</script>

<template>
  <Page auto-content-height>
    <FormEditModal :close-on-click-modal="false" @success="handelSuccess" />
    <Grid>
      <template #toolbar-tools>
        <Button
          class="mr-2"
          type="primary"
          v-access:code="'menu:add'"
          @click="() => handleEdit({}, false)"
        >
          新增菜单
        </Button>
      </template>
      <template #action="{ row }">
        <TableAction
          :actions="[
            {
              label: '添加项',
              type: 'text',
              disabled: !hasAccessByCodes(['menu:add']),
              onClick: handleEdit.bind(null, { pid: row.id }, false),
            },
            {
              label: '编辑',
              type: 'text',
              danger: true,
              disabled: !hasAccessByCodes(['menu:edit']),
              onClick: handleEdit.bind(null, { id: row.id }, true),
            },
          ]"
          :drop-down-actions="[
            {
              label: '删除',
              type: 'link',
              disabled: !hasAccessByCodes(['menu:delete']),
              onClick: handleDelete.bind(null, row.id),
            },
          ]"
        />
      </template>
    </Grid>
  </Page>
</template>
